#include "filter_msg.h"

void report_vm(filter_msg *v)
{
	unsigned mylen = v->errmsg ? strlen(v->errmsg) : 0;
	printf(
		"errmsglen = %u%s diff=%u\n"
		"%s\n",
		v->errmsglen,
		mylen == v->errmsglen ? "" : " DIFFERENT THAN ACTUAL STRLEN!!",
		v->lasterrmsg - v->errmsg,
		v->errmsg ? v->errmsg : "(null)");
}

int main(int argc, char *argv[])
{
	int i;
	filter_msg vm;
	
	filter_msg_init(&vm);
	report_vm(&vm);
	
	for (i = 1; i < argc; ++i)
	{
		char ttt[32];
		filter_msg_action action = (i - 1) % (msg_drop + 1);
		sprintf(ttt, "type%d", action);
		if (filter_msg_add(&vm, ttt, argv[i], action))
			return 1; // out of memory
		report_vm(&vm);
	}
	
	report_vm(&vm);
	filter_msg_clear(&vm);
	(void)&filter_msg_detach;
	return 0;
}
